CREATE TABLE orgs (name VARCHAR(20) NOT NULL, description VARCHAR(50), PRIMARY KEY(name));

CREATE TABLE people (	name VARCHAR(50) NOT NULL , 
						email VARCHAR(50) NOT NULL UNIQUE, 
						home_phone VARCHAR(32) NOT NULL);

CREATE INDEX peoplebyname ON people (name, email);
					
CREATE TABLE absence (	email VARCHAR(50) NOT NULL, 
						startdate DATE NOT NULL, 
						enddate DATE NOT NULL,
						tod VARCHAR(3) NOT NULL, 
						reason VARCHAR(9) NOT NULL, 
						alt_phone VARCHAR(10), 
						details VARCHAR(80),
						updatestamp INTEGER GENERATED ALWAYS AS IDENTITY);


CREATE TABLE teams (name VARCHAR(20) NOT NULL, description VARCHAR(50), orgname VARCHAR(20) REFERENCES orgs(name), PRIMARY KEY(name, orgname));
CREATE TABLE messages (msg_id INTEGER UNIQUE NOT NULL, date VARCHAR(10), sender BLOB, subject BLOB, text BLOB);
CREATE TABLE orgmembers(name VARCHAR(20) NOT NULL references orgs(name), email VARCHAR(50) NOT NULL REFERENCES people(email));

CREATE TABLE teammembers(name VARCHAR(20) NOT NULL, member_email VARCHAR(50) NOT NULL REFERENCES people(email), 
							PRIMARY KEY(name, member_email));

CREATE TABLE notifications (notified_person VARCHAR(50) NOT NULL REFERENCES people(email), 
							absent_person VARCHAR(50) NOT NULL REFERENCES people(email), PRIMARY KEY(notified_person, absent_person));
CREATE TABLE teamnotifications (notified_person VARCHAR(50) NOT NULL REFERENCES people(email),
                            team_name VARCHAR(20) NOT NULL, org_name VARCHAR(20) NOT NULL, PRIMARY KEY(notified_person, team_name, org_name));

create view latestabsence (email, updatestamp) AS select email, max(updatestamp) from absence where startdate <= CURRENT_DATE and enddate >= CURRENT_DATE group by email;
create index membershipteam on teammembers (member_email asc, name asc);
